org.modeshape.jcr.query.optimize

## Class JoinOrder

- java.lang.Object
- - org.modeshape.jcr.query.optimize.JoinOrder

- All Implemented Interfaces:
    OptimizerRule

      public class JoinOrder
      extends Object
      implements OptimizerRule

  An optimization rule that ensure that the order of the left and right side of a JOIN match certain join criteria, including `DescendantNodeJoinCondition` and `ChildNodeJoinCondition`.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static JoinOrder` | `INSTANCE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JoinOrder()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PlanNode` | `execute(QueryContext context, PlanNode plan, LinkedList<OptimizerRule> ruleStack)` Optimize the supplied plan using the supplied context, hints, and yet-to-be-run rules.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### INSTANCE

          public static final JoinOrder INSTANCE

  - ### Constructor Detail

    - #### JoinOrder

          public JoinOrder()

  - ### Method Detail

    - #### execute

          public PlanNode execute(QueryContext context,
                         PlanNode plan,
                         LinkedList<OptimizerRule> ruleStack)

      Description copied from interface: `OptimizerRule`
      Optimize the supplied plan using the supplied context, hints, and yet-to-be-run rules.
      Specified by:
        `execute` in interface `OptimizerRule`
      Parameters:
        `context` - the context in which the query is being optimized; never null
        `plan` - the plan to be optimized; never null
        `ruleStack` - the stack of rules that will be run after this rule; never null
      Returns:
        the optimized plan; never null

Copyright © 2008-2014 JBoss, a division of Red Hat. All Rights Reserved.